package org.jeecg.modules.fault.controller;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import lombok.extern.slf4j.Slf4j;
import org.apache.shiro.SecurityUtils;
import org.jeecg.common.api.vo.Result;
import org.jeecg.common.aspect.annotation.AutoLog;
import org.jeecg.common.system.base.controller.JeecgController;
import org.jeecg.common.system.query.QueryGenerator;
import org.jeecg.common.system.vo.LoginUser;
import org.jeecg.modules.device.entity.BuDevice;
import org.jeecg.modules.device.service.IBuDeviceService;
import org.jeecg.modules.fault.entity.BuFaultDispatch;
import org.jeecg.modules.fault.service.IBuFaultDispatchService;
import org.jeecg.modules.repair.entity.BuDeviceMaintenance;
import org.jeecg.modules.repair.entity.BuRepairRecord;
import org.jeecg.modules.repair.service.IBuDeviceMaintenanceService;
import org.jeecg.modules.repair.service.IBuRepairRecordService;
import org.jeecg.modules.system.entity.SysDepart;
import org.jeecg.modules.system.entity.SysUser;
import org.jeecg.modules.system.service.ISysDepartService;
import org.jeecg.modules.system.service.ISysUserService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.servlet.ModelAndView;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.util.Arrays;
import java.util.Date;

 /**
 * @Description: 派发计划表
 * @Author: jeecg-boot
 * @Date:   2021-01-13
 * @Version: V1.0
 */
@Api(tags="故障提票表")
@RestController
@RequestMapping("/fault/buFaultDispatch")
@Slf4j
public class BuFaultDispatchController extends JeecgController<BuFaultDispatch, IBuFaultDispatchService> {
	@Autowired
	private IBuFaultDispatchService buFaultDispatchService;
	@Autowired
	private IBuRepairRecordService buRepairRecordService;
	@Autowired
	private IBuDeviceMaintenanceService buDeviceMaintenanceService;
	@Autowired
	private ISysUserService sysUserService;
	@Autowired
	private IBuDeviceService buDeviceService;
	@Autowired
	private ISysDepartService sysDepartService;


	/**
	 * 分页列表查询
	 *
	 * @param buFaultDispatch
	 * @param pageNo
	 * @param pageSize
	 * @param req
	 * @return
	 */
	@AutoLog(value = "故障派工表-分页列表查询")
	@ApiOperation(value="故障派工表-分页列表查询", notes="故障派工表-分页列表查询")
	@GetMapping(value = "/list")
	public Result<?> queryPageList(BuFaultDispatch buFaultDispatch,
								   @RequestParam(name="pageNo", defaultValue="1") Integer pageNo,
								   @RequestParam(name="pageSize", defaultValue="10") Integer pageSize,
								   HttpServletRequest req) {
		QueryWrapper<BuFaultDispatch> queryWrapper = QueryGenerator.initQueryWrapper(buFaultDispatch, req.getParameterMap());
		Page<BuFaultDispatch> page = new Page<BuFaultDispatch>(pageNo, pageSize);
		IPage<BuFaultDispatch> pageList = buFaultDispatchService.page(page, queryWrapper);
		return Result.OK(pageList);
	}

	/**
	 *   添加
	 *
	 * @param buFaultDispatch
	 * @return
	 */
	@AutoLog(value = "故障派工表-添加")
	@ApiOperation(value="故障派工表-添加", notes="故障派工表-添加")
	@PostMapping(value = "/add")
	public Result<?> add(@RequestBody BuFaultDispatch buFaultDispatch) {
		LoginUser user = (LoginUser) SecurityUtils.getSubject().getPrincipal();
		SysUser sysUser = sysUserService.getUserByName(buFaultDispatch.getUserId());
		SysDepart sysDepart = sysDepartService.getDepartsByOrgCode(sysUser.getOrgCode());
		BuDevice buDevice = buDeviceService.getById(buFaultDispatch.getDeviceId());
		if (buFaultDispatch.getIsClose().equals("0")) {
			BuRepairRecord buRepairRecord = new BuRepairRecord();
			buRepairRecord.setDeviceId(buFaultDispatch.getDeviceId());
			buRepairRecord.setDeviceName(buDevice.getDeviceName());
			buRepairRecord.setRepairGrade(buFaultDispatch.getFaultGrade());
			buRepairRecord.setRepairType(buFaultDispatch.getFaultType());
			buRepairRecord.setDescription(buFaultDispatch.getFaultDes());
			buRepairRecord.setAssignerId(sysUser.getId());
			buRepairRecord.setIsClose(buFaultDispatch.getIsClose());
			buRepairRecord.setOrgCode(sysUser.getOrgCode());
			buRepairRecord.setOrgName(sysDepart.getDepartName());
			buRepairRecord.setSubmitId(user.getId());
			buRepairRecord.setSubmitTime(new Date());
			buRepairRecord.setRepairStatus("0");
			buRepairRecordService.save(buRepairRecord);
		}else if (buFaultDispatch.getIsClose().equals("1")) {
			BuDeviceMaintenance buDeviceMaintenance = new BuDeviceMaintenance();
			buDeviceMaintenance.setDeviceName(buFaultDispatch.getDeviceId());
			buDeviceMaintenance.setSubmitId(user.getId());
			buDeviceMaintenance.setSubmitTime(new Date());
			buDeviceMaintenance.setAssignerId(sysUser.getId());
			buDeviceMaintenance.setTaskStatus(0);
			buDeviceMaintenanceService.save(buDeviceMaintenance);
		}
		buFaultDispatchService.save(buFaultDispatch);
		return Result.OK("添加成功！");
	}

	/**
	 *  编辑
	 *
	 * @param buFaultDispatch
	 * @return
	 */
	@AutoLog(value = "故障派工表-编辑")
	@ApiOperation(value="故障派工表-编辑", notes="故障派工表-编辑")
	@PutMapping(value = "/edit")
	public Result<?> edit(@RequestBody BuFaultDispatch buFaultDispatch) {
		buFaultDispatchService.updateById(buFaultDispatch);
		return Result.OK("编辑成功!");
	}

	/**
	 *   通过id删除
	 *
	 * @param id
	 * @return
	 */
	@AutoLog(value = "故障派工表-通过id删除")
	@ApiOperation(value="故障派工表-通过id删除", notes="故障派工表-通过id删除")
	@DeleteMapping(value = "/delete")
	public Result<?> delete(@RequestParam(name="id",required=true) String id) {
		buFaultDispatchService.removeById(id);
		return Result.OK("删除成功!");
	}

	/**
	 *  批量删除
	 *
	 * @param ids
	 * @return
	 */
	@AutoLog(value = "故障派工表-批量删除")
	@ApiOperation(value="故障派工表-批量删除", notes="故障派工表-批量删除")
	@DeleteMapping(value = "/deleteBatch")
	public Result<?> deleteBatch(@RequestParam(name="ids",required=true) String ids) {
		this.buFaultDispatchService.removeByIds(Arrays.asList(ids.split(",")));
		return Result.OK("批量删除成功!");
	}

	/**
	 * 通过id查询
	 *
	 * @param id
	 * @return
	 */
	@AutoLog(value = "故障派工表-通过id查询")
	@ApiOperation(value="故障派工表-通过id查询", notes="故障派工表-通过id查询")
	@GetMapping(value = "/queryById")
	public Result<?> queryById(@RequestParam(name="id",required=true) String id) {
		BuFaultDispatch buFaultDispatch = buFaultDispatchService.getById(id);
		if(buFaultDispatch==null) {
			return Result.error("未找到对应数据");
		}
		return Result.OK(buFaultDispatch);
	}

    /**
    * 导出excel
    *
    * @param request
    * @param buFaultDispatch
    */
    @RequestMapping(value = "/exportXls")
    public ModelAndView exportXls(HttpServletRequest request, BuFaultDispatch buFaultDispatch) {
        return super.exportXls(request, buFaultDispatch, BuFaultDispatch.class, "故障派工表");
    }

    /**
      * 通过excel导入数据
    *
    * @param request
    * @param response
    * @return
    */
    @RequestMapping(value = "/importExcel", method = RequestMethod.POST)
    public Result<?> importExcel(HttpServletRequest request, HttpServletResponse response) {
        return super.importExcel(request, response, BuFaultDispatch.class);
    }

}
